classdef CurveType_LP < handle
    %CURVETYPE_LP Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        branches
    end
    
    methods
        function obj = CurveType_LP()
           obj.branches = struct(); 
            
           obj.branches.LP = { Branch('LP','LP', @init_LPm_LPm , 1 , false,'D+bps') };
           obj.branches.CP = { Branch('CP','LP', @init_LPm_LPm , 1 , false,'D+bps') };
           obj.branches.R1 = { Branch('R1','LP', @init_LPm_LPm , 1 , false,'D+bps') };
           obj.branches.LPPD = { Branch('LPPD','LP', @init_LPm_LPm , 1 , false,'D+bps') };
           obj.branches.LPNS = { Branch('LPNS','LP', @init_LPm_LPm , 1 , false,'D+bps') };
           
           obj.branches.GPD = { Branch('GPD','LP', @init_GPD_LP2m , 2 , false,'eps+bps') };
           
           obj.branches.R4 = { Branch('R4','LP', @init_R4_LP4m1 , 4 , true,'eps+bps'),...
                               Branch('R4','LP', @init_R4_LP4m2,  4 , true,'eps+bps')};
           
        end

        function string = getName(obj)
            string = 'Limit Point';
        end
        function string = getLabel(obj)
            string = 'LP';
        end
        
        function col = getDefaultColor(obj)
           col = 'green'; 
        end        
        function [list,mindim] = getTestfunctions(obj)
            list =   {'R1' , 'LPPD' , 'LPNS' , 'CP'};
            mindim = [ 2   ,   2    ,   3    ,  1  ];
        end
        
        function list = getNumericVarList(obj)
            %toevoeging van een testfunctie bij elke branch (CP)
            list = {'coordinates','parameters','testfunctions','multipliers' ,'current_stepsize' , 'user_functions' , 'npoints'};
        end
        %------------------------------------------------------
        function list  = allowedStarterOptions(obj)
            
             list = {'coordinates' , 'parameters' , 'ADnumber' , 'jacobian' , 'iterationN' , 'multipliers' ,'userfunction' , 'testfunctions' , 'amplitude' };
            
        end
        
        function list = getDependantGlobalVars(obj)
            list = {'cds' , 'lpmds'};
        end
        
        function curvedef = getCurveDefinition(obj)
            curvedef = @limitpointmap;
        end
        
        function [x0,v0] = performInit(obj, session, curve, x0 , par, systemhandle,varargin)
            initpointtag = session.getPointType().getLabel();
            n = session.starterdata.getSetting('iterationN');
            
            option_eps = 0.0001;
            option_whichLP = 1;
            switch initpointtag
                
                case 'LP'
                    disp('WARNING: unsure about CALL'); % FIXME
                    [x0,v0] = init_LP_FP(systemhandle,x0,par, session.starterdata.getActiveParams(),n); %FIXME ????
                    
                case 'R4'
                    if option_whichLP == 1  %UNSETTABLE in matcont
                        [x0,v0] = init_R4_LP4m1(systemhandle,option_eps ,x0, par, session.starterdata.getActiveParams(),n);%VARARGIN: branchparam
                    else
                        [x0,v0] = init_R4_LP4m2(systemhandle,option_eps ,x0, par, session.starterdata.getActiveParams(),n);%VARARGIN: branchparam
                    end
                    
                case 'GPD'
                    
                    [x0,v0] = init_GPD_LP2m(systemhandle,eps, x0, par, session.starterdata.getActiveParams() ,n);%VARARGIN: branchparam
                    
                otherwise
                    [x0,v0] = init_LPm_LPm(systemhandle, x0, par, session.starterdata.getActiveParams(),n); %VARARGIN: branchparam
            end
            
            
        end
        function bool = supportPoint(obj, pointtag)
            bool = ismember(pointtag, {'LP','R4' , 'GPD'});
        end        
        
        function nr = getReqNrFreeParams(obj)
           nr = 2; 
        end
        
        function list = getBranches(obj, pointtag)
           if (isfield(obj.branches,pointtag))
               list = obj.branches.(pointtag);
           else
               list = {};
           end
            
        end
        function mat = getSingMatrix(obj)
           out = feval(obj.getCurveDefinition());
           mat = feval(out{9});
        end
    end
    
end
