classdef NumericOptionPanel < handle
    %NUMERICOPTIONPANEL Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        panelhandle
        layoutstructure
    end
    
    methods
        
        function obj = NumericOptionPanel(parent, numvarlist , varargin)
           obj.panelhandle = uipanel(parent, 'Unit' , 'Pixels' , 'BackgroundColor' , [0.95 0.95 0.95] , varargin{:});
           set(obj.panelhandle,'DeleteFcn' , @(o,e) obj.destructor() , 'ResizeFcn' , @(o,e) obj.onResize(o) );
           obj.organize(numvarlist);
            
        end
        
        function organize(obj , numvarlist)
           mainnode = LayoutNode(-1 , -1 , 'vertical');
           
           optionlist = numvarlist.getOptions();
           for i=1:length(optionlist)
               
               mainnode.addGUIobject(1,1, ...
                  SwitchBox(obj.panelhandle , 'checkbox' , optionlist{i} ,  @(x) numvarlist.setNumVarEnabled( optionlist{i} , x)   , @() numvarlist.isNumVarEnabled(optionlist{i}), ...
                       numvarlist  ,  'BackgroundColor' , [0.95 0.95 0.95], 'HorizontalAlignment' , 'left' , 'FontSize', 12)  ...
                , 'minsize' , [Inf,20] ,'halign' , 'c');
           end
           
           mainnode.makeLayoutHappen( get(obj.panelhandle, 'Position'));
           obj.layoutstructure = mainnode;
            
        end
        function destructor(obj)
            %D disp(['Destructor: ' mfilename]);
            obj.layoutstructure.destructor();
            delete(obj);
        end

        function onResize(obj,handle)
            set(handle,'Units' , 'Pixels');
            pos = get(handle, 'Position');
            if (~isempty(pos)) 
                obj.layoutstructure.makeLayoutHappen( get(handle, 'Position'));
            end
            set(handle,'Units' , 'normalize');
        end
        
    end
    
end

